package com.ic.er.common;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import com.ic.er.Relationship;

import java.io.IOException;

public class RelationshipSerializer extends StdSerializer<Relationship> {

    public RelationshipSerializer() {
        this(null);
    }

    public RelationshipSerializer(Class<Relationship> t) {
        super(t);
    }

    @Override
    public void serialize(
            Relationship relationship, JsonGenerator jgen, SerializerProvider provider)
            throws IOException {

        jgen.writeStartObject();
        jgen.writeStringField("name", relationship.getName());
        jgen.writeStringField("firstEntity", relationship.getFirstEntity().getName());
        jgen.writeStringField("secondEntity", relationship.getSecondEntity().getName());
        jgen.writeStringField("cardinality", relationship.getCardinality().toString());
        jgen.writeEndObject();
    }
}